Package org.apache.sling.jcr.contentloader

# Class PathEntry

java.lang.Object
org.apache.sling.jcr.contentloader.ImportOptions
org.apache.sling.jcr.contentloader.PathEntry

public class PathEntry extends ImportOptions
A path entry from the manifest for initial content.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`AUTOCHECKOUT_DIRECTIVE`
The autoCheckout directive specifying whether versionable nodes should be checked out when necessary
`static final String`
`CHECKIN_DIRECTIVE`
The checkin directive specifying whether versionable nodes should be checked in
`static final String`
`CONTENT_HEADER`
The manifest header to specify initial content to be loaded.
`static final String`
`IGNORE_CONTENT_READERS_DIRECTIVE`
The ignore content readers directive specifying whether the available `ContentReader`s should be used during content loading.
`static final String`
`MERGE_NODES_DIRECTIVE`
The overwriteProperties directive specifying if content properties should be overwritten or just initially added.
`static final String`
`MERGE_PROPERTIES_DIRECTIVE`
The overwriteProperties directive specifying if content properties should be overwritten or just initially added.
`static final String`
`OVERWRITE_DIRECTIVE`
The overwrite directive specifying if content should be overwritten or just initially added.
`static final String`
`OVERWRITE_PROPERTIES_DIRECTIVE`
The overwriteProperties directive specifying if content properties should be overwritten or just initially added.
`static final String`
`PATH_DIRECTIVE`
The path directive specifying the target node where initial content will be loaded.
`static final String`
`REQUIRE_CONTENT_READERS_DIRECTIVE`
The require content readers directive specifying which of the available `ContentReader`s should exist before content loading.
`static final String`
`UNINSTALL_DIRECTIVE`
The uninstall directive specifying if content should be uninstalled.
`protected static final Set<String>`
`VALID_DIRECTIVES`
All directive names which are valid for header Sling-Initial-Content
`static final String`
`WORKSPACE_DIRECTIVE`
The workspace into which the content will be loaded.

## Constructor Summary

Constructors
Constructor
Description
`PathEntry(org.apache.sling.commons.osgi.ManifestHeader.Entry entry, long bundleLastModified)`
`PathEntry(org.apache.sling.commons.osgi.ManifestHeader.Entry entry, long bundleLastModified, @Nullable String bundleSymbolicName)`

## Method Summary

Modifier and Type
Method
Description
`static @Nullable Iterator<PathEntry>`
`getContentPaths(@NotNull Manifest manifest, long bundleLastModified)`
Parses the "Sling-Initial-Content" header from the given manifest and returns the resolved PathEntries
`static @Nullable Iterator<PathEntry>`
`getContentPaths(Map<String,String> headers, long bundleLastModified)`
Parses the "Sling-Initial-Content" header from the given headers and returns the resolved PathEntries
`static @Nullable Iterator<PathEntry>`
`getContentPaths(org.osgi.framework.Bundle bundle)`
Parses the "Sling-Initial-Content" header from the given bundle and returns the resolved PathEntries
`Set<String>`
`getIgnoredContentReaders()`
`long`
`getLastModified()`
`String`
`getPath()`
`String`
`getTarget()`
`String`
`getWorkspace()`
`boolean`
`isAutoCheckout()`
Specifies whether versionable nodes is automatically checked out when necessary.
`boolean`
`isCheckin()`
Specifies whether versionable nodes is automatically checked in at the end of the import operation.
`boolean`
`isIgnoredImportProvider(String extension)`
Check if the content reader for the given file extension should be ignored.
`boolean`
`isImportProviderRequired(@NotNull String name)`
Check if the given entry name should require a matching registered import provider.
`boolean`
`isMerge()`
Specifies whether imported nodes should merge with existing nodes.
`boolean`
`isOverwrite()`
Specifies whether imported nodes should overwrite existing nodes.
`boolean`
`isPropertyMerge()`
Specifies whether imported properties should merge with existing properties.
`boolean`
`isPropertyOverwrite()`
Specifies whether imported properties should overwrite existing properties.
`boolean`
`isUninstall()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### CONTENT_HEADER

public static final String CONTENT_HEADER
The manifest header to specify initial content to be loaded.

See Also:
  - Constant Field Values

### OVERWRITE_DIRECTIVE

public static final String OVERWRITE_DIRECTIVE
The overwrite directive specifying if content should be overwritten or just initially added.

See Also:
  - Constant Field Values

### OVERWRITE_PROPERTIES_DIRECTIVE

public static final String OVERWRITE_PROPERTIES_DIRECTIVE
The overwriteProperties directive specifying if content properties should be overwritten or just initially added.

See Also:
  - Constant Field Values

### MERGE_PROPERTIES_DIRECTIVE

public static final String MERGE_PROPERTIES_DIRECTIVE
The overwriteProperties directive specifying if content properties should be overwritten or just initially added.

See Also:
  - Constant Field Values

### MERGE_NODES_DIRECTIVE

public static final String MERGE_NODES_DIRECTIVE
The overwriteProperties directive specifying if content properties should be overwritten or just initially added.

See Also:
  - Constant Field Values

### UNINSTALL_DIRECTIVE

public static final String UNINSTALL_DIRECTIVE
The uninstall directive specifying if content should be uninstalled.

See Also:
  - Constant Field Values

### PATH_DIRECTIVE

public static final String PATH_DIRECTIVE
The path directive specifying the target node where initial content will be loaded.

See Also:
  - Constant Field Values

### WORKSPACE_DIRECTIVE

public static final String WORKSPACE_DIRECTIVE
The workspace into which the content will be loaded.

See Also:
  - Constant Field Values

### CHECKIN_DIRECTIVE

public static final String CHECKIN_DIRECTIVE
The checkin directive specifying whether versionable nodes should be checked in

See Also:
  - Constant Field Values

### AUTOCHECKOUT_DIRECTIVE

public static final String AUTOCHECKOUT_DIRECTIVE
The autoCheckout directive specifying whether versionable nodes should be checked out when necessary

See Also:
  - Constant Field Values

### IGNORE_CONTENT_READERS_DIRECTIVE

public static final String IGNORE_CONTENT_READERS_DIRECTIVE
The ignore content readers directive specifying whether the available `ContentReader`s should be used during content loading. This is a string value that defaults to the emptystring.

Since:
  2.0.4
See Also:
  - Constant Field Values

### REQUIRE_CONTENT_READERS_DIRECTIVE

public static final String REQUIRE_CONTENT_READERS_DIRECTIVE
The require content readers directive specifying which of the available `ContentReader`s should exist before content loading. This is a string value that defaults to the emptystring.

Since:
  2.5.2
See Also:
  - Constant Field Values

### VALID_DIRECTIVES

protected static final Set<String> VALID_DIRECTIVES
All directive names which are valid for header Sling-Initial-Content

## Constructor Details

### PathEntry

public PathEntry(org.apache.sling.commons.osgi.ManifestHeader.Entry entry, long bundleLastModified)

### PathEntry

public PathEntry(org.apache.sling.commons.osgi.ManifestHeader.Entry entry, long bundleLastModified, @Nullable @Nullable String bundleSymbolicName)

## Method Details

### getContentPaths

@Nullable public static @Nullable Iterator<PathEntry> getContentPaths(@NotNull @NotNull Manifest manifest, long bundleLastModified)
Parses the "Sling-Initial-Content" header from the given manifest and returns the resolved PathEntries

Parameters:
  `manifest` - the manifest
  `bundleLastModified` - the timestamp when the bundle has been last modified or -1 if not known
Returns:
  an iterator over the parsed `PathEntry` items or `null` in case no "Sling-Initial-Content" header was found in the manifest

### getContentPaths

@Nullable public static @Nullable Iterator<PathEntry> getContentPaths(org.osgi.framework.Bundle bundle)
Parses the "Sling-Initial-Content" header from the given bundle and returns the resolved PathEntries

Parameters:
  `bundle` - the bundle
Returns:
  an iterator over the parsed `PathEntry` items or `null` in case no "Sling-Initial-Content" header was found in the bundle's manifest

### getContentPaths

@Nullable public static @Nullable Iterator<PathEntry> getContentPaths(Map<String,String> headers, long bundleLastModified)
Parses the "Sling-Initial-Content" header from the given headers and returns the resolved PathEntries

Parameters:
  `headers` - the manifest headers
  `bundleLastModified` - the timestamp when the bundle has been last modified or -1 if not known
Returns:
  an iterator over the parsed `PathEntry` items or `null` in case no "Sling-Initial-Content" header was found

### getLastModified

public long getLastModified()

### getPath

public String getPath()

### isOverwrite

public boolean isOverwrite()
Description copied from class: `ImportOptions`
Specifies whether imported nodes should overwrite existing nodes. NOTE: this means the existing node will be deleted and a new node will be created in the same location.

Specified by:
  `isOverwrite` in class `ImportOptions`
Returns:
  true to overwrite nodes, false otherwise

### isPropertyOverwrite

public boolean isPropertyOverwrite()
Description copied from class: `ImportOptions`
Specifies whether imported properties should overwrite existing properties.

Specified by:
  `isPropertyOverwrite` in class `ImportOptions`
Returns:
  true to overwrite node properties, false otherwise

### isUninstall

public boolean isUninstall()

### isCheckin

public boolean isCheckin()
Description copied from class: `ImportOptions`
Specifies whether versionable nodes is automatically checked in at the end of the import operation.

Specified by:
  `isCheckin` in class `ImportOptions`
Returns:
  true to checkin the versionable nodes, false otherwise

### isAutoCheckout

public boolean isAutoCheckout()
Description copied from class: `ImportOptions`
Specifies whether versionable nodes is automatically checked out when necessary.

Overrides:
  `isAutoCheckout` in class `ImportOptions`
Returns:
  true to checkout the versionable nodes, false otherwise

### isIgnoredImportProvider

public boolean isIgnoredImportProvider(String extension)
Description copied from class: `ImportOptions`
Check if the content reader for the given file extension should be ignored.

Specified by:
  `isIgnoredImportProvider` in class `ImportOptions`
Parameters:
  `extension` - the extension to check
Returns:
  true to ignore the reader, false otherwise

### getIgnoredContentReaders

public Set<String> getIgnoredContentReaders()

### isImportProviderRequired

public boolean isImportProviderRequired(@NotNull @NotNull String name)
Description copied from class: `ImportOptions`
Check if the given entry name should require a matching registered import provider.

Specified by:
  `isImportProviderRequired` in class `ImportOptions`
Parameters:
  `name` - the entry name to check
Returns:
  true to require an import provider, false otherwise

### getTarget

public String getTarget()

### getWorkspace

public String getWorkspace()

### isPropertyMerge

public boolean isPropertyMerge()
Description copied from class: `ImportOptions`
Specifies whether imported properties should merge with existing properties. NOTE: this means that properties that are not imported will be removed

Overrides:
  `isPropertyMerge` in class `ImportOptions`
Returns:
  true to overwrite nodes, false otherwise

### isMerge

public boolean isMerge()
Description copied from class: `ImportOptions`
Specifies whether imported nodes should merge with existing nodes. NOTE: this means the existing nodes that are not imported will be deleted.

Overrides:
  `isMerge` in class `ImportOptions`
Returns:
  true to overwrite nodes, false otherwise